<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>48.50</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">

    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini">
    <!-- Site wrapper -->
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">User list</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->

        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
                 with font-awesome or any other icon font library -->
                        <li class="nav-item">
                            <a href="#" class="nav-link">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="index1.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="index2.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="index.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="../index.html" class="nav-link active">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    Dashboard V3
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>

        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <section class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1>Danh sách người dùng</h1>
                        </div>
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">Dashboard V3</li>
                            </ol>
                        </div>
                    </div>
                </div><!-- /.container-fluid -->
            </section>

            <!-- Main content -->
            <section class="content">
                <div class="jumbotron container">
                    <div class="row form-group">
                        <div class="col-sm-3">
                            <label for="roleSelect">Role</label>
                        </div>
                        <div class="col-sm-6">
                            <select id="roleSelect" class="form-control"></select>
                        </div>
                        <div class="col-sm-3">
                            <button id="btn-filter-role" class="btn btn-info">Lọc dữ liệu</button>
                        </div>
                    </div>
                </div>
                <table class="table table-bordered table-striped table-hover" id="user-table">
                    <thead>
                        <tr>
                            <th>STT</th>
                            <th>Username</th>
                            <th>First name</th>
                            <th>Last name</th>
                            <th>Email</th>
                            <th>Age</th>
                            <th>Role</th>
                            <th>Action</th>
                        </tr>
                    </thead>
                </table>
            </section>
        </div>

        <!-- Vùng Modal -->
        <!-- Footer -->
        <footer class="main-footer">
            <div class="float-right d-none d-sm-block">
                <b>Version</b> 1.0.0
            </div>
            <strong>Copyright &copy; 2023 Devcamp.</strong> All rights
            reserved.
        </footer>

    </div>

    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <!-- AdminLTE for demo purposes -->
    <!-- <script src="dist/js/demo.js"></script> -->
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
        var gUserObjects = [
            {
                id: 2,
                username: "quannv",
                firstname: "Ngo Van",
                lastname: "Quan",
                age: 18,
                email: "quan@gmail.com",
                roleId: 5
            },
            {
                id: 3,
                username: "longdh",
                firstname: "Do Hoang",
                lastname: "Long",
                age: 19,
                email: "long@gmail.com",
                roleId: 8
            },
            {
                id: 4,
                username: "hiendt",
                firstname: "Do Thi",
                lastname: "Hien",
                age: 29,
                email: "hien@gmail.com",
                roleId: 11
            },
            {
                id: 6,
                username: "lanht",
                firstname: "Ho Thi",
                lastname: "Lan",
                age: 27,
                email: "lan@gmail.com",
                roleId: 13
            }
        ];

        var gRoleObjects = [
            {
                roleId: 5,
                roleName: "Admin"
            },
            {
                roleId: 8,
                roleName: "Manager"
            },
            {
                roleId: 11,
                roleName: "Teacher"
            },
            {
                roleId: 13,
                roleName: "Staff"
            }
        ];

        const gSTT_COL = 0;
        const gUSER_NAME_COL = 1;
        const gFIRST_NAME_COL = 2;
        const gLAST_NAME_COL = 3;
        const gEMAIL_COL = 4;
        const gAGE_COL = 5;
        const gROLE_COL = 6;
        const gACTION_COL = 7;

        /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
        $(document).ready(function () {
            onPageLoading();
        });

        /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
        function onPageLoading() {
            loadDataToRoleSelect();
            showTableUserDataTable();
            $('[data-toggle="tooltip"]').tooltip();
        }

        $("#btn-filter-role").on("click", function () {
            onBtnFilterRoleClick();
        });

        function onBtnFilterRoleClick() {
            var vFilterRoleId = {
                roleId: -1
            };
            getFilterFormatData(vFilterRoleId);
            filterRoles(vFilterRoleId);
        }

        function loadDataToRoleSelect() {
            var vRoleSelect = $("#roleSelect");
            $("<option/>", {
                text: "--- Chọn tất cả ---",
                value: 0
            }).appendTo(vRoleSelect);

            for (let bI = 0; bI < gRoleObjects.length; bI++) {
                var bRoleOption = $("<option/>", {
                    text: gRoleObjects[bI].roleName,
                    value: gRoleObjects[bI].roleId
                }).appendTo(vRoleSelect);
            }
        }

        function showTableUserDataTable() {
            $("#user-table").DataTable({
                data: gUserObjects,
                columns: [
                    { data: "id" },
                    { data: "username" },
                    { data: "firstname" },
                    { data: "lastname" },
                    { data: "email" },
                    { data: "age" },
                    { data: "roleId" },
                    { data: null }
                ],
                columnDefs: [
                    {
                        targets: gSTT_COL,
                        className: "text-center text-primary",
                        render: function (data, type, row, meta) {
                            return meta.row + meta.settings._iDisplayStart + 1;
                        }
                    },
                    {
                        targets: gROLE_COL,
                        className: "text-right",
                        render: mappingRoleNameByID
                    },
                    {
                        targets: gACTION_COL,
                        className: "text-center",
                        defaultContent: `
                  <button class="btn btn-link" data-toggle="tooltip" data-placement="bottom" title="Dice History"><i class="fas fa-dice text-success"></i></button>
                  <button class="btn btn-link btn-sm" data-toggle="tooltip" data-placement="bottom" title="Voucher History"><i class="fas fa-gift text-success"></i></button>`
                    }
                ]
            });
        }

        function mappingRoleNameByID(paramData, paramType, paramRow) {
            for (let bI = 0; bI < gRoleObjects.length; bI++) {
                const bRoleObjItem = gRoleObjects[bI];
                if (paramData == bRoleObjItem.roleId) {
                    return bRoleObjItem.roleName;
                }
            }
        }

        function filterRoles(paramFilterFormatObj) {
            var vRoleResult = [];
            vRoleResult = gUserObjects.filter(function (paramOrder) {
                return (
                    paramFilterFormatObj.roleId === 0 ||
                    paramOrder.roleId === paramFilterFormatObj.roleId
                );
            });
            loadRolesToTable(vRoleResult);
        }

        function getFilterFormatData(paramFilterFormatObj) {
            paramFilterFormatObj.roleId = parseInt($("#roleSelect").val(), 10);
        }

        function loadRolesToTable(paramOrderArr) {
            var dataTable = $("#user-table").DataTable();
            dataTable.clear();
            dataTable.rows.add(paramOrderArr);
            dataTable.draw();
        }
    </script>

</body>

</html>